package com.dcsoft.system.service;

import java.util.List;

import com.dcsoft.system.api.domain.SysDept;
import com.dcsoft.system.domain.SysBranch;
import com.dcsoft.system.domain.SysPeople;
import com.dcsoft.system.domain.vo.JjserInfoVo;
import com.dcsoft.system.domain.vo.TreeSelect;
import com.dcsoft.system.domain.vo.TreeSelectVo;

/**
 * 部门管理Service接口
 *
 * @author dcsoft
 * @date 2023-03-07
 */
public interface ISysBranchService
{
    /**
     * 查询部门管理
     *
     * @param id 部门管理主键
     * @return 部门管理
     */
    public SysBranch selectSysBranchById(String id);

    /**
     * 查询部门管理列表
     *
     * @param sysBranch 部门管理
     * @return 部门管理集合
     */
    public List<SysBranch> selectSysBranchList(SysBranch sysBranch);

    /**
     * 新增部门管理
     *
     * @param sysBranch 部门管理
     * @return 结果
     */
    public int insertSysBranch(SysBranch sysBranch);

    /**
     * 修改部门管理
     *
     * @param sysBranch 部门管理
     * @return 结果
     */
    public int updateSysBranch(SysBranch sysBranch);

    /**
     * 批量删除部门管理
     *
     * @param ids 需要删除的部门管理主键集合
     * @return 结果
     */
    public int deleteSysBranchByIds(String[] ids);

    /**
     * 删除部门管理信息
     *
     * @param id 部门管理主键
     * @return 结果
     */
    public int deleteSysBranchById(Long id);

    /**
     * 查询部门树结构信息
     *
     * @param branch 部门信息
     * @return 部门树信息集合
     */
    public List<TreeSelectVo> selectBranchTreeList(SysBranch branch);

    /**
     * 构建前端所需要树结构
     *
     * @param branchs 部门列表
     * @return 树结构列表
     */
    public List<SysBranch> buildBranchTree(List<SysBranch> branchs);

    /**
     * 构建前端所需要下拉树结构
     *
     * @param branchs 部门列表
     * @return 下拉树结构列表
     */
    public List<TreeSelectVo> buildBranchTreeSelect(List<SysBranch> branchs);

    public SysBranch selectSysBranchByDeptId(Long parentId);

    List<TreeSelectVo> queryBranchTree(SysBranch space);

    /**
     * 同步部门（锦江）
     */
    void saveBranchTree(SysBranch space);

    /**
     * 同步人员（锦江）
     */
    void saveUserInfo(List<JjserInfoVo> data);

    /**
     * 同步岗位（锦江）
     */
    void saveStation(SysBranch space);


    public int deleteSysBranchByBranchId(String id);

    public int updateSysBranchs(SysBranch sysBranch);

    public int insertSysBranchs(SysBranch sysBranch);

    /**
     * 查询部门树
     */
    List<TreeSelectVo> queryDeptInfo(SysBranch paramVo);

    /**
     * 查询物业子部门
     * @return
     */
    List<SysBranch> queryPropertyDept(String parentId);

    /**
     * 查询
     * @param branchId
     * @return
     */
    List<SysBranch> queryJuniorBranch(String branchId);
}
